{    var   : }
{ ALF, BTA, NN }
Unit QSJ1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, QSJAC_p;

procedure QSJ1R(var RINT :Real; A :Real; B :Real; var ALF :Real;
                var BTA :Real; F :Func_F1; var NN :Integer);

implementation

procedure QSJ1R(var RINT :Real; A :Real; B :Real; var ALF :Real;
                var BTA :Real; F :Func_F1; var NN :Integer);
var
N,J :Integer;
SAB,DBA,FN,FN1,Q1,Q2,Q3,Q4,Q5,P,S :Real;
X :Array [0..511] of Real;
W :Array [0..511] of Real;
AC :Array [0..511] of Real;
BC :Array [0..511] of Real;
CC :Array [0..511] of Real;
label
_1,_2;
begin
SAB := ALF+BTA;
DBA := ALF-BTA;
P := SAB*DBA;
AC[0] := 0.0;
BC[0] := 0.0;
CC[0] := 0.0;
for N:=2 to 512 do
 begin
  FN := N;
  FN1 := N-1;
  Q1 := 2.0*FN+SAB;
  Q2 := Q1-1.0;
  Q3 := SAB+FN;
  Q4 := FN*Q3;
  Q5 := Q4*(Q1-2.0);
  AC[N-1] := Q1*Q2/(2.0*Q4);
  BC[N-1] := P*Q2/(2.0*Q5);
  CC[N-1] := Q1*(ALF+FN1)*(BTA+FN1)/Q5;
_1:
 end;
QSJAC(X,W,ALF,BTA,NN,AC,BC,CC)                     ;
S := 0.0;
for J:=1 to NN do
 begin
_2:
  S := S+W[J-1]*F(0.5*((B-A)*X[J-1]+A+B));
 end;
RINT := S;
end;

end.
