Unit QSJAC2_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UtDiag_p, UTQSJAC_p;

function QSJAC2(W :Real): Real;

implementation

function QSJAC2(W :Real): Real;
var
M,FK,IK,I :Integer;
X,XPI,Y,Z,ZZ,P :Real;
const
SYS001 :Real = 3.1415926535897932384626433832795;
label
_1,_2,_3,_4,_5,_6,_7,_8,_10,_11;
begin
X := W;
M := 0;
FK := Trunc(-1.0);
if ( X-0.5 ) < 0
 then goto _1
 else if ( X-0.5 ) > 0
       then goto _2
       else goto _2;
_1:
M := 1;
XPI := X*SYS001;
X := 1.0-X;
_2:
FK := FK+Trunc(1.0);
if ( X+FK-6.0 ) < 0
 then goto _2
 else if ( X+FK-6.0 ) > 0
       then goto _3
       else goto _2;
_3:
Z := X+FK;
ZZ := Z*Z;
Y := (Z-0.5)*Ln(Z)-Z+0.9189385+
    (((((-4146.0/ZZ+1820.0)/ZZ-1287.0)/ZZ+
    1716.0)/ZZ-6006.0)/ZZ+180180.0)/Z/2162160.0;
if ( FK ) < 0
 then goto _6
 else if ( FK ) > 0
       then goto _4
       else goto _6;
_4:
IK := FK;
for I:=1 to IK do
 begin
  FK := FK-Trunc(1.0);
_5:
  Y := Y-Ln(X+FK);
 end;
_6:
if ( M ) < 0
 then goto _7
 else if ( M ) > 0
       then goto _7
       else goto _11;
_7:
P := SYS001/Sin(XPI);
if ( P ) < 0
 then goto _8
 else if ( P ) > 0
       then goto _10
       else goto _8;
_8:
UTQSJAC(W);
Y := 0.0;
goto _11;
_10:
Y := Ln(P)-Y;
_11:
Result := Y;
exit;
end;

end.
