Unit QSJAC1_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure QSJAC1(var X :Real; NN :Integer; ALF :Real; BTA :Real;
                var DPN :Real; var PN1 :Real; var A :Array of Real;
                var B :Array of Real; var C :Array of Real);

implementation

procedure QSJAC1(var X :Real; NN :Integer; ALF :Real; BTA :Real;
                var DPN :Real; var PN1 :Real; var A :Array of Real;
                var B :Array of Real; var C :Array of Real);
var
ITER,J :Integer;
P,P1,DP,DP1,PN,Q,DQ,RQ,D :Real;
label
_1,_2,_3,_4;
begin
ITER := 0;
_1:
ITER := ITER+1;
P1 := 1.0;
P := 0.5*((ALF+BTA+2.0)*X+ALF-BTA);
DP1 := 0.0;
DP := 0.5*(ALF+BTA)+1.0;
for J:=2 to NN do
 begin
  RQ := A[J-1]*X+B[J-1];
  Q := RQ*P-C[J-1]*P1;
  DQ := RQ*DP+A[J-1]*P-C[J-1]*DP1;
  P1 := P;
  P := Q;
  DP1 := DP;
_2:
  DP := DQ;
 end;
PN := P;
DPN := DP;
PN1 := P1;
D := PN/DPN;
X := X-D;
if ( Abs(D)-1.E-6 ) < 0
 then goto _4
 else if ( Abs(D)-1.E-6 ) > 0
       then goto _3
       else goto _4;
_3:
if ( ITER-10 ) < 0
 then goto _1
 else if ( ITER-10 ) > 0
       then goto _4
       else goto _4;
_4:
end;

end.
