{    var   : }
{ NN, ALF, BTA, A, B, C }
Unit QSJAC_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, QSJAC1_p, QSJAC2_p;

procedure QSJAC(var X :Array of Real; var W :Array of Real;
                var ALF :Real; var BTA :Real; var NN :Integer;
                var A :Array of Real; var B :Array of Real;
                var C :Array of Real);

implementation

procedure QSJAC(var X :Array of Real; var W :Array of Real;
                var ALF :Real; var BTA :Real; var NN :Integer;
                var A :Array of Real; var B :Array of Real;
                var C :Array of Real);
var
J,I :Integer;
FN,BETA,CC,AN,BN,R1,R2,R3,XT,RATIO,RC,DPN,P,PN1 :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12;
begin
FN := NN;
BETA := Exp(QSJAC2(ALF+1.0)+QSJAC2(BTA+1.0)-QSJAC2(ALF+BTA+2.0));
CC := Power(2.0,ALF+BTA+1.0)*BETA;
CC := 0.5*(ALF+BTA+2.0)*CC;
for J:=2 to NN do
 begin
_1:
  CC := CC*C[J-1];
 end;
for I:=1 to NN do
 begin
  if ( I-1 ) < 0
   then goto _12
   else if ( I-1 ) > 0
         then goto _3
         else goto _2;
_2:
  AN := ALF/FN;
  BN := BTA/FN;
  R1 := (1.0+ALF)*(2.78/(4.0+FN*FN)+0.768*AN/FN);
  R2 := 1.0+1.48*AN+0.96*BN+0.452*AN*AN+0.83*AN*BN;
  XT := 1.0-R1/R2;
  goto _11;
_3:
  if ( I-2 ) < 0
   then goto _12
   else if ( I-2 ) > 0
         then goto _5
         else goto _4;
_4:
  R1 := (4.1+ALF)/((1.0+ALF)*(1.0+0.156*ALF));
  R2 := 1.0+0.06*(FN-8.0)*(1.0+0.12*ALF)/FN;
  R3 := 1.0+0.012*BTA*(1.0+0.25*Abs(ALF))/FN;
  RATIO := R1*R2*R3;
  XT := XT-RATIO*(1.0-XT);
  goto _11;
_5:
  if ( I-3 ) < 0
   then goto _12
   else if ( I-3 ) > 0
         then goto _7
         else goto _6;
_6:
  R1 := (1.67+0.28*ALF)/(1.0+0.37*ALF);
  R2 := 1.0+0.22*(FN-8.0)/FN;
  R3 := 1.0+8.0*BTA/((6.28+BTA)*FN*FN);
  RATIO := R1*R2*R3;
  XT := XT-RATIO*(X[0]-XT);
  goto _11;
_7:
  if ( NN-I-1 ) < 0
   then goto _10
   else if ( NN-I-1 ) > 0
         then goto _8
         else goto _9;
_8:
  XT := 3.0*X[I-2]-3.0*X[I-3]+X[I-4];
  goto _11;
_9:
  R1 := (1.0+0.235*BTA)/(0.766+0.119*BTA);
  R2 := 1.0/(1.0+0.639*(FN-4.0)/(1.0+0.71*(FN-4.0)));
  R3 := 1.0/(1.0+20.0*ALF/((7.5+ALF)*FN*FN));
  RATIO := R1*R2*R3;
  XT := XT+RATIO*(XT-X[I-3]);
  goto _11;
_10:
  R1 := (1.0+0.37*BTA)/(1.67+0.28*BTA);
  R2 := 1.0/(1.0+0.22*(FN-8.0)/FN);
  R3 := 1.0/(1.0+8.0*ALF/((6.28+ALF)*FN*FN));
  RATIO := R1*R2*R3;
  XT := XT+RATIO*(XT-X[I-3]);
_11:
  QSJAC1(XT,NN,ALF,BTA,DPN,PN1,A,B,C);
  X[I-1] := XT;
  RC := CC/DPN/PN1;
  W[I-1] := RC;
_12:
 end;
end;

end.
